package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.comun.UtilsConfig;
import com.ejie.ab79.model.Inspectores;
import com.ejie.ab79.model.nora.T17Provincia;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * InspectoresDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class InspectoresDaoImpl implements InspectoresDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDINSPECTOR", "USUARIOXLNETS", "FECHAREGISTRO",
			"USUARIOREGISTRO", "NOMBREINSPECTOR", "DESCASTELLANO", "DESCEUSKERA", "DSO", "NUMEROINSPECTOR", "DNI" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Inspectores> rwMap = new RowMapper<Inspectores>() {
		public Inspectores mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Inspectores inspector = new Inspectores();
			inspector.setIdInspector(resultSet.getInt("IDINSPECTOR"));
			inspector.setUsuarioXlnets(resultSet.getString("USUARIOXLNETS"));
			inspector.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			inspector.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			inspector.setNombreInspector(resultSet.getString("NOMBREINSPECTOR"));
			inspector.setDni(resultSet.getString("DNI"));
			inspector.setNumeroInspector(resultSet.getString("NUMEROINSPECTOR"));

			T17Provincia provincia = new T17Provincia();
			provincia.setId(resultSet.getString("IDTERRITORIOHISTORICO"));
			if (provincia.getId() != null) {
				if (provincia.getId().length() == 1) {
					provincia.setId("0" + provincia.getId());
				}
			}
			provincia.setDsO(resultSet.getString("DSO"));

			inspector.setProvincia(provincia);

			return inspector;
		}
	};

	private RowMapper<Inspectores> rwMapByIdInspector = new RowMapper<Inspectores>() {
		public Inspectores mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Inspectores inspector = new Inspectores();
			inspector.setIdInspector(resultSet.getInt("IDINSPECTOR"));
			inspector.setUsuarioXlnets(resultSet.getString("USUARIOXLNETS"));
			inspector.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			inspector.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			inspector.setNombreInspector(resultSet.getString("NOMBREINSPECTOR"));
			inspector.setDni(resultSet.getString("DNI"));
			inspector.setNumeroInspector(resultSet.getString("NUMEROINSPECTOR"));

			T17Provincia provincia = new T17Provincia();
			provincia.setId(resultSet.getString("IDTERRITORIOHISTORICO"));
			if (provincia.getId() != null) {
				if (provincia.getId().length() == 1) {
					provincia.setId("0" + provincia.getId());
				}
			}
			provincia.setDsO(resultSet.getString("DSO"));

			inspector.setProvincia(provincia);

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DESCASTELLANO"));
			direccion.setDescripcionEuskera(resultSet.getString("DESCEUSKERA"));

			inspector.setDireccion(direccion);

			return inspector;
		}
	};

	private RowMapper<Inspectores> rwMapPK = new RowMapper<Inspectores>() {
		public Inspectores mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Inspectores(resultSet.getInt("IDINSPECTOR"));
		}
	};

	private RowMapper<Inspectores> rwMapFindAll = new RowMapper<Inspectores>() {
		public Inspectores mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Inspectores inspector = new Inspectores();
			inspector.setIdInspector(resultSet.getInt("IDINSPECTOR"));
			inspector.setUsuarioXlnets(resultSet.getString("USUARIOXLNETS"));
			inspector.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			inspector.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			inspector.setNombreInspector(resultSet.getString("NOMBREINSPECTOR"));
			inspector.setDni(resultSet.getString("DNI"));
			inspector.setNumeroInspector(resultSet.getString("NUMEROINSPECTOR"));
			inspector.setPasswordTablet(resultSet.getString("PASSWORDTABLET"));

			return inspector;
		}
	};

	private RowMapper<Inspectores> rwMapFindAllREST = new RowMapper<Inspectores>() {
		public Inspectores mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Inspectores inspector = new Inspectores();
			inspector.setIdInspector(resultSet.getInt("IDINSPECTOR"));
			inspector.setUsuarioXlnets(resultSet.getString("USUARIOXLNETS"));
			inspector.setNombreInspector(resultSet.getString("NOMBREINSPECTOR"));
			inspector.setNumeroInspector(resultSet.getString("NUMEROINSPECTOR"));
			inspector.setPasswordTablet(resultSet.getString("PASSWORDTABLET"));

			T17Provincia provincia = new T17Provincia();
			provincia.setId(resultSet.getString("IDTERRITORIOHISTORICO"));
			inspector.setProvincia(provincia);

			return inspector;
		}
	};

	private RowMapper<Inspectores> rwMapFindAllLike = new RowMapper<Inspectores>() {
		public Inspectores mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Inspectores inspector = new Inspectores();
			inspector.setIdInspector(resultSet.getInt("IDINSPECTOR"));
			inspector.setUsuarioXlnets(resultSet.getString("USUARIOXLNETS"));
			inspector.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			inspector.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			inspector.setNombreInspector(resultSet.getString("NOMBREINSPECTOR"));
			inspector.setDni(resultSet.getString("DNI"));
			inspector.setNumeroInspector(resultSet.getString("NUMEROINSPECTOR"));

			T17Provincia provincia = new T17Provincia();
			provincia.setId(resultSet.getString("IDTERRITORIOHISTORICO"));
			if (provincia.getId() != null) {
				if (provincia.getId().length() == 1) {
					provincia.setId("0" + provincia.getId());
				}
			}
			provincia.setDsO(resultSet.getString("DSO"));

			inspector.setProvincia(provincia);

			return inspector;
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<Inspectores>> rwMapJerarquia = new RowMapper<JerarquiaDto<Inspectores>>() {
		public JerarquiaDto<Inspectores> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Inspectores inspectores = new Inspectores(resultSet.getInt("IDINSPECTOR"),
					resultSet.getString("USUARIOXLNETS"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"), resultSet.getString("NOMBREINSPECTOR"));

			JerarquiaDto<Inspectores> jerarquia = new JerarquiaDto<Inspectores>();
			jerarquia.setModel(inspectores);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the Inspectores table.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @return Inspectores
	 */
	public Inspectores add(Inspectores inspectores) {

		int idInspector = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7904T00.NEXTVAL FROM DUAL",
				Integer.class);

		String idProvincia = "";
		if (inspectores.getProvincia() != null) {
			idProvincia = inspectores.getProvincia().getId();
		}

		String query = "INSERT INTO INSPECTORES (ID_INSPECTOR, USUARIO_XLNETS, FECHA_REGISTRO, USUARIO_REGISTRO, NOMBRE_INSPECTOR, BAJA, ID_TERRITORIO_HISTORICO, NUMERO_INSPECTOR, DNI, PASSWORD_TABLET) VALUES (?,?,sysdate,?,?,?,?,?,?,?)";
		this.jdbcTemplate.update(query, idInspector, inspectores.getUsuarioXlnets(), inspectores.getUsuarioRegistro(),
				inspectores.getNombreInspector(), Constantes.BAJA, idProvincia, inspectores.getNumeroInspector(),
				inspectores.getDni(), inspectores.getPasswordTablet());

		if (inspectores.getIdDirecciones() != null) {
			for (Integer direccion : inspectores.getIdDirecciones()) {
				int idRelDirIns = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7923T00.NEXTVAL FROM DUAL",
						Integer.class);

				String queryRelDirIns = "INSERT INTO REL_DIR_INS (ID_REL_DIR_INS, ID_DIRECCION, ID_INSPECTOR, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,sysdate,?)";
				this.jdbcTemplate.update(queryRelDirIns, idRelDirIns, direccion, idInspector,
						inspectores.getUsuarioRegistro());
			}
		}

		return inspectores;
	}

	/**
	 * Updates a single row in the Inspectores table.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @return Inspectores
	 */
	public Inspectores update(Inspectores inspectores) {

		String idProvincia = "";
		if (inspectores.getProvincia() != null) {
			idProvincia = inspectores.getProvincia().getId();
		}

		String query = "UPDATE INSPECTORES SET USUARIO_XLNETS=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=?, NOMBRE_INSPECTOR=?, ID_TERRITORIO_HISTORICO=?, NUMERO_INSPECTOR=?, DNI=?, PASSWORD_TABLET=? WHERE ID_INSPECTOR=?";
		this.jdbcTemplate.update(query, inspectores.getUsuarioXlnets(), inspectores.getUsuarioUltModificacion(),
				inspectores.getNombreInspector(), idProvincia, inspectores.getNumeroInspector(), inspectores.getDni(),
				inspectores.getPasswordTablet(), inspectores.getIdInspector());

		if (inspectores.getIdDirecciones() != null) {

			String queryDeleteRelDirIns = "DELETE FROM REL_DIR_INS WHERE ID_INSPECTOR=?";
			this.jdbcTemplate.update(queryDeleteRelDirIns, inspectores.getIdInspector());

			for (Integer direccion : inspectores.getIdDirecciones()) {
				int idRelDirIns = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7923T00.NEXTVAL FROM DUAL",
						Integer.class);

				String queryRelDirIns = "INSERT INTO REL_DIR_INS (ID_REL_DIR_INS, ID_DIRECCION, ID_INSPECTOR, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,sysdate,?)";
				this.jdbcTemplate.update(queryRelDirIns, idRelDirIns, direccion, inspectores.getIdInspector(),
						inspectores.getUsuarioRegistro());
			}
		}

		return inspectores;
	}

	/**
	 * Finds a single row in the Inspectores table.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @return Inspectores
	 */
	@Transactional(readOnly = true)
	public Inspectores find(Inspectores inspectores) {
		String query = "SELECT t1.ID_INSPECTOR IDINSPECTOR, t1.USUARIO_XLNETS USUARIOXLNETS, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR, t1.ID_TERRITORIO_HISTORICO IDTERRITORIOHISTORICO, t1.NUMERO_INSPECTOR NUMEROINSPECTOR, t1.DNI DNI, t2.DS_O DSO FROM INSPECTORES t1, "
				+ UtilsConfig.getAppProperties().getProperty("NORA.DB")
				+ ".T17_PROVINCIA t2  WHERE t1.ID_INSPECTOR = ? AND t1.ID_TERRITORIO_HISTORICO = t2.ID(+)";

		List<Inspectores> inspectoresList = this.jdbcTemplate.query(query, this.rwMap, inspectores.getIdInspector());
		return (Inspectores) DataAccessUtils.uniqueResult(inspectoresList);
	}

	@Override
	public Inspectores findByUsuarioXLNETS(Inspectores inspectores) {
		String query = "SELECT t1.ID_INSPECTOR IDINSPECTOR, t1.USUARIO_XLNETS USUARIOXLNETS, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR, t1.ID_TERRITORIO_HISTORICO IDTERRITORIOHISTORICO, t1.NUMERO_INSPECTOR NUMEROINSPECTOR, t1.DNI DNI, t2.DS_O DSO FROM INSPECTORES t1, "
				+ UtilsConfig.getAppProperties().getProperty("NORA.DB")
				+ ".T17_PROVINCIA t2  WHERE t1.USUARIO_XLNETS = ? AND t1.BAJA = 0 AND t1.ID_TERRITORIO_HISTORICO = t2.ID(+) ";

		List<Inspectores> inspectoresList = this.jdbcTemplate.query(query, this.rwMap, inspectores.getUsuarioXlnets());
		return (Inspectores) DataAccessUtils.uniqueResult(inspectoresList);
	}

	/**
	 * Removes a single row in the Inspectores table.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @return
	 */
	public void remove(Inspectores inspectores) {
		String query = "UPDATE INSPECTORES SET BAJA=1, FECHA_ULTMODIFICACION = SYSDATE, USUARIO_ULTMODIFICACION = ? WHERE ID_INSPECTOR=?";
		this.jdbcTemplate.update(query, inspectores.getUsuarioUltModificacion(), inspectores.getIdInspector());

		String queryDeleteRelDirIns = "DELETE FROM REL_DIR_INS WHERE ID_INSPECTOR=?";
		this.jdbcTemplate.update(queryDeleteRelDirIns, inspectores.getIdInspector());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<Inspectores> getMultiple(Inspectores filterInspectores, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterInspectores, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, Inspectores.class, params,
				"ID_INSPECTOR");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the Inspectores table.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<Inspectores>
	 */
	@Transactional(readOnly = true)
	public List<Inspectores> findAll(Inspectores inspectores, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_INSPECTOR IDINSPECTOR,t1.USUARIO_XLNETS USUARIOXLNETS,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR, t1.ID_TERRITORIO_HISTORICO IDTERRITORIOHISTORICO, t1.NUMERO_INSPECTOR NUMEROINSPECTOR, t1.DNI DNI, t1.PASSWORD_TABLET PASSWORDTABLET ");
		query.append("FROM INSPECTORES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(inspectores);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, InspectoresDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<Inspectores>) this.jdbcTemplate.query(query.toString(), this.rwMapFindAll, params.toArray());
	}

	@Override
	public List<Inspectores> findAllREST(Inspectores filterInspectores) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_INSPECTOR IDINSPECTOR, t1.USUARIO_XLNETS USUARIOXLNETS, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR, t1.ID_TERRITORIO_HISTORICO IDTERRITORIOHISTORICO, t1.NUMERO_INSPECTOR NUMEROINSPECTOR, t1.PASSWORD_TABLET PASSWORDTABLET ");
		query.append("FROM INSPECTORES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(filterInspectores);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return (List<Inspectores>) this.jdbcTemplate.query(query.toString(), this.rwMapFindAllREST, params.toArray());
	}

	@Override
	public List<Inspectores> findTodosInspectores(Inspectores inspectores, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t7904.ID_INSPECTOR IDINSPECTOR,t7904.USUARIO_XLNETS USUARIOXLNETS,t7904.FECHA_REGISTRO FECHAREGISTRO,t7904.USUARIO_REGISTRO USUARIOREGISTRO, t7904.NOMBRE_INSPECTOR NOMBREINSPECTOR, t7904.ID_TERRITORIO_HISTORICO IDTERRITORIOHISTORICO, t7904.NUMERO_INSPECTOR NUMEROINSPECTOR, t7904.DNI DNI, t7904.PASSWORD_TABLET PASSWORDTABLET ");
		query.append(" FROM INSPECTORES t7904 ");

		// Se le indica que solo obtenga los inspectores de alta
		if (inspectores.getBaja() != null && inspectores.getBaja().equals(0)) {
			query.append(" WHERE (t7904.BAJA = 0 OR t7904.BAJA IS NULL) ");
		}

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, InspectoresDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<Inspectores>) this.jdbcTemplate.query(query.toString(), this.rwMapFindAll);
	}

	/**
	 * Finds rows in the Inspectores table using like.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Inspectores>
	 */
	@Transactional(readOnly = true)
	public List<Inspectores> findAllLike(Inspectores inspectores, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT DISTINCT t1.ID_INSPECTOR IDINSPECTOR,t1.USUARIO_XLNETS USUARIOXLNETS,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR, t1.ID_TERRITORIO_HISTORICO IDTERRITORIOHISTORICO, t1.NUMERO_INSPECTOR NUMEROINSPECTOR, t1.DNI DNI, t3.DS_O DSO ");
		query.append(
				"FROM INSPECTORES t1, " + UtilsConfig.getAppProperties().getProperty("NORA.DB") + ".T17_PROVINCIA t3, REL_DIR_INS t4, DIRECCIONES t5 ");

		// Where clause & Params

		Map<String, ?> mapaWhere = this.getWhereLikeMap(inspectores, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);
		List<?> params = (List<?>) mapaWhere.get("params");

		// el tableRequestDto sirve para filtrar por las columnas
		if (tableRequestDto != null) {
			// tableRequestDto.setSidx("t1.ID_INSPECTOR");
			query = TableManager.getPaginationQuery(tableRequestDto, query);
		}

		return (List<Inspectores>) this.jdbcTemplate.query(query.toString(), this.rwMapFindAllLike, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Inspectores table.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(Inspectores inspectores) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM INSPECTORES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(inspectores);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Inspectores table using like.
	 *
	 * @param inspectores
	 *            Inspectores
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Inspectores inspectores, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(DISTINCT t1.ID_INSPECTOR) FROM INSPECTORES t1, "
				+ UtilsConfig.getAppProperties().getProperty("NORA.DB") + ".T17_PROVINCIA t3, REL_DIR_INS t4, DIRECCIONES t5 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(inspectores, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of Inspectores selected for rup_table
	 *
	 * @param inspectores
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Inspectores>>
	 */
	@Override
	public List<TableRowDto<Inspectores>> reorderSelection(Inspectores inspectores, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECTOR IDINSPECTOR,t1.USUARIO_XLNETS USUARIOXLNETS,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR ");
		// FROM
		query.append("FROM INSPECTORES t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(inspectores, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, Inspectores.class,
				filterParamList, "ID_INSPECTOR");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Inspectores>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            Inspectores
	 * @param searchParams
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Inspectores>>
	 */
	@Override
	public List<TableRowDto<Inspectores>> search(Inspectores filterParams, Inspectores searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECTOR IDINSPECTOR,t1.USUARIO_XLNETS USUARIOXLNETS,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO t1.NOMBRE_INSPECTOR NOMBREINSPECTOR ");
		// FROM
		query.append("FROM INSPECTORES t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, Inspectores.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_INSPECTOR");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Inspectores>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterinspectores
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Inspectores filterinspectores, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECTOR IDINSPECTOR,t1.USUARIO_XLNETS USUARIOXLNETS,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR ");
		// FROM
		query.append("FROM INSPECTORES t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterinspectores, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, Inspectores.class,
				query, params, "ID_INSPECTOR");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical Inspectores table.
	 *
	 * @param filterInspectores
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<Inspectores>>
	 */
	@Override
	public List<JerarquiaDto<Inspectores>> findAllLikeJerarquia(Inspectores filterInspectores,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECTOR IDINSPECTOR,t1.USUARIO_XLNETS USUARIOXLNETS,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM INSPECTORES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("INSPECTORES");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterInspectores, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_INSPECTOR", "ID_PADRE", "NOMBRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					InspectoresDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterInspectores
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(Inspectores filterInspectores, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM INSPECTORES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("INSPECTORES");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterInspectores, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_INSPECTOR",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterInspectores
	 *            Inspectores
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<Inspectores>>
	 */
	@Override
	public List<TableRowDto<Inspectores>> findAllChild(Inspectores filterInspectores, TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM INSPECTORES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("INSPECTORES");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterInspectores, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_INSPECTOR",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<Inspectores>(this.rwMapPK, "ID_INSPECTOR"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Inspectores entity
	 *
	 * @param inspectores
	 *            Inspectores Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Inspectores inspectores) {

		StringBuilder where = new StringBuilder(InspectoresDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		where.append("AND (t1.BAJA = 0 OR t1.BAJA IS NULL)");

		if (inspectores != null && inspectores.getIdInspector() != null) {
			where.append(" AND t1.ID_INSPECTOR = ?");
			params.add(inspectores.getIdInspector());
		}
		if (inspectores != null && inspectores.getUsuarioXlnets() != null) {
			where.append(" AND t1.USUARIO_XLNETS = ?");
			params.add(inspectores.getUsuarioXlnets());
		}
		if (inspectores != null && inspectores.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(inspectores.getFechaRegistro());
		}
		if (inspectores != null && inspectores.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(inspectores.getUsuarioRegistro());
		}
		if (inspectores != null && inspectores.getNombreInspector() != null) {
			where.append(" AND t1.NOMBRE_INSPECTOR = ?");
			params.add(inspectores.getNombreInspector());
		}
		if (inspectores != null && inspectores.getProvincia() != null && inspectores.getProvincia().getId() != null) {
			where.append(" AND t1.ID_TERRITORIO_HISTORICO = ?");
			params.add(inspectores.getProvincia().getId());
		}

		if (inspectores != null && inspectores.getPasswordTablet() != null) {
			where.append(" AND t1.PASSWORD_TABLET = ?");
			params.add(inspectores.getPasswordTablet());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Inspectores entity
	 *
	 * @param inspectores
	 *            Inspectores Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(Inspectores inspectores, Boolean startsWith) {

		StringBuilder where = new StringBuilder(InspectoresDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		where.append(
				" AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_TERRITORIO_HISTORICO = t3.ID(+) AND t1.ID_INSPECTOR = t4.ID_INSPECTOR AND t4.ID_DIRECCION = t5.ID_DIRECCION ");

		if (inspectores != null && inspectores.getIdInspector() != null) {
			where.append(" AND t1.ID_INSPECTOR = ?");
			params.add(inspectores.getIdInspector());
		}
		if (inspectores != null && inspectores.getUsuarioXlnets() != null) {
			where.append(" AND UPPER(t1.USUARIO_XLNETS) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspectores.getUsuarioXlnets().toUpperCase() + "%");
			} else {
				params.add("%" + inspectores.getUsuarioXlnets().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_XLNETS IS NOT NULL");
		}
		if (inspectores != null && inspectores.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(inspectores.getFechaRegistro());
		}
		if (inspectores != null && inspectores.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspectores.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + inspectores.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		if (inspectores != null && inspectores.getProvincia() != null && inspectores.getProvincia().getId() != null) {
			where.append(" AND t1.ID_TERRITORIO_HISTORICO = ?");
			params.add(inspectores.getProvincia().getId());
		}
		if (inspectores != null && inspectores.getDireccion() != null
				&& inspectores.getDireccion().getIdDireccion() != null) {
			where.append(" AND t5.ID_DIRECCION = ?");
			params.add(inspectores.getDireccion().getIdDireccion());
		}
		if (inspectores != null && inspectores.getDni() != null) {
			where.append(" AND UPPER(t1.DNI) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspectores.getDni().toUpperCase() + "%");
			} else {
				params.add("%" + inspectores.getDni().toUpperCase() + "%");
			}
			where.append(" AND t1.DNI IS NOT NULL");
		}
		if (inspectores != null && inspectores.getNombreInspector() != null) {
			where.append(" AND UPPER(t1.NOMBRE_INSPECTOR) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspectores.getNombreInspector().toUpperCase() + "%");
			} else {
				params.add("%" + inspectores.getNombreInspector().toUpperCase() + "%");
			}
			where.append(" AND t1.NOMBRE_INSPECTOR IS NOT NULL");
		}
		if (inspectores != null && inspectores.getNumeroInspector() != null) {
			// where.append(" AND t1.NUMERO_INSPECTOR = ?");
			// params.add(inspectores.getNumeroInspector());
			where.append(" AND t1.NUMERO_INSPECTOR like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspectores.getNumeroInspector() + "%");
			} else {
				params.add("%" + inspectores.getNumeroInspector() + "%");
			}
			where.append(" AND t1.NUMERO_INSPECTOR IS NOT NULL");
		}
		if (inspectores != null && inspectores.getProvincia() != null && inspectores.getProvincia().getDsO() != null) {
			where.append(" AND t1.ID_TERRITORIO_HISTORICO = ?");
			params.add(inspectores.getProvincia().getDsO());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	@Override
	public Inspectores findByIdInspector(Inspectores inspectores) {
		String query = "SELECT t1.ID_INSPECTOR IDINSPECTOR, t1.USUARIO_XLNETS USUARIOXLNETS, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.NOMBRE_INSPECTOR NOMBREINSPECTOR, t1.ID_TERRITORIO_HISTORICO IDTERRITORIOHISTORICO, t1.NUMERO_INSPECTOR NUMEROINSPECTOR, t1.DNI DNI, t2.DS_O DSO, t3.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_CASTELLANO DESCASTELLANO, t3.DESCRIPCION_EUSKERA DESCEUSKERA FROM INSPECTORES t1, T17I.T17_PROVINCIA t2, DIRECCIONES T3, REL_DIR_INS T4 WHERE t1.ID_INSPECTOR = ? AND t1.ID_TERRITORIO_HISTORICO = t2.ID(+) AND t1.ID_INSPECTOR = T4.ID_INSPECTOR AND t4.ID_DIRECCION = t3.ID_DIRECCION";

		List<Inspectores> inspectoresList = this.jdbcTemplate.query(query, this.rwMapByIdInspector,
				inspectores.getIdInspector());

		List<Inspectores> inspectoresListAux = new ArrayList<Inspectores>();

		if (inspectoresList.size() != 0) {

			Inspectores inspector = new Inspectores();

			inspector.setIdInspector(inspectoresList.get(0).getIdInspector());
			inspector.setUsuarioXlnets(inspectoresList.get(0).getUsuarioXlnets());
			inspector.setFechaRegistro(inspectoresList.get(0).getFechaRegistro());
			inspector.setUsuarioRegistro(inspectoresList.get(0).getUsuarioRegistro());
			inspector.setNombreInspector(inspectoresList.get(0).getNombreInspector());
			inspector.setNumeroInspector(inspectoresList.get(0).getNumeroInspector());
			inspector.setDni(inspectoresList.get(0).getDni());

			T17Provincia provincia = new T17Provincia();
			provincia.setId(inspectoresList.get(0).getProvincia().getId());
			if (provincia.getId() != null) {
				if (provincia.getId().length() == 1) {
					provincia.setId("0" + provincia.getId());
				}
			}
			provincia.setDsO(inspectoresList.get(0).getProvincia().getDsO());
			inspector.setProvincia(provincia);

			List<Integer> direccionesIds = new ArrayList<Integer>();

			for (int x = 0; x < inspectoresList.size(); x++) {
				direccionesIds.add(inspectoresList.get(x).getDireccion().getIdDireccion());
			}

			inspector.setIdDirecciones(direccionesIds);

			inspectoresListAux.add(inspector);
		}

		return (Inspectores) DataAccessUtils.uniqueResult(inspectoresListAux);
	}

}
